Bug 1122146 - Growing linear RAID array causes error "cannot understand this RAID level"
Summary: Growing linear RAID array causes error "cannot understand this RAID level"
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: mdadm
Version: 20
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jes Sorensen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-07-22 16:00 UTC by mulhern
Modified: 2014-08-15 02:51 UTC (History)
4 users (show)

Fixed In Version: mdadm-3.3-7.fc20
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-08-15 02:51:05 UTC


Attachments (Terms of Use)
Information requested (3.08 KB, text/plain)
2014-07-22 19:25 UTC, mulhern
no flags Details

Description mulhern 2014-07-22 16:00:26 UTC
Description of problem:

Attempting to grow linear array from 2 to 3 using command "mdadm --grow <array> --raid-devices 3 "--add <device>" results in failure and error message "cannot understand this RAID level"


Version-Release number of selected component (if applicable):

3.3

How reproducible:

Always (through a testing infrastructure on top of loop devices)

Steps to Reproduce:
1. Create the array as "mdadm --create <array> --run --level=linear --raid-devices=2 <dev1> <dev2>
2. Grow the array as "mdadm --grow <array> --raid-devices 3 "--add <device>"

Actual results:

"cannot understand this RAID level" error message

Expected results:

Array is grown or more upbeat message something like
"mdadm: ddf metadata does not support reshape"

Additional info:

mddetail returns the following information on the array just before the grow call,

ACTIVE DEVICES: 2
ARRAY SIZE: 204640 (199.88 MiB 209.55 MB)
CREATION TIME: Tue Jul 22 11:27:11 2014
EVENTS: 0
FAILED DEVICES: 0
NAME: localhost.localdomain:0  (local to host localhost.localdomain)
PERSISTENCE: Superblock is persistent
RAID DEVICES: 2
RAID LEVEL: linear
ROUNDING: 0K
SPARE DEVICES: 0
STATE: clean
TOTAL DEVICES: 2
UPDATE TIME: Tue Jul 22 11:27:11 2014
UUID: f240dfa0-a97e-1012-adfe-772006af61f9
VERSION: 1.2
WORKING DEVICES: 2

This is through the testing structure, so the formatting of the output is
not as mddetail would have it.

Comment 1 Jes Sorensen 2014-07-22 16:16:28 UTC
Please provide 'cat /proc/mdstat' and 'mdadm --detail /dev/md<X>' output.

Comment 2 mulhern 2014-07-22 19:25:57 UTC
Created attachment 920037 [details]
Information requested

The attached file contains the information requested which was obtained immediately after creation of the array and just before the attempt to grow the array, adding an additional device. Note that it was obtained from within the Python debugger.

Comment 3 Jes Sorensen 2014-07-23 14:17:18 UTC
I can reproduce this, however it looks to be a very long standing bug, as 
the same happens with mdadm-3.2.6.

I am not sure if growing a linear array is even supported in the first place,
I will need to investigate this.

Jes

Comment 4 mulhern 2014-07-24 15:05:27 UTC
It is also not possible to use --add to add a new disk to an existing linear array. AFAIK, this means that increasing the size of a linear array after it has been created is impossible.

Comment 5 Jes Sorensen 2014-07-24 15:54:41 UTC
Not correct, after investigation, it's the fact you cannot use -n with linear
arrays. 

Try something like this: 
mdadm /dev/md<X> -G -a /dev/sd<Y>

Comment 6 Fedora Update System 2014-07-29 10:54:26 UTC
mdadm-3.3-7.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/mdadm-3.3-7.fc20

Comment 7 Fedora Update System 2014-07-30 06:56:09 UTC
Package mdadm-3.3-7.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing mdadm-3.3-7.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-8956/mdadm-3.3-7.fc20
then log in and leave karma (feedback).

Comment 8 Fedora Update System 2014-08-15 02:51:05 UTC
mdadm-3.3-7.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.